/* Integer Version 2.0, RD, 4.2.93	Int.cc	*/


#include <iostream.h>
#include "Int.h"

int Ilog(const Int &a)	
	{ return Ilog(&a.I); }
	
Int operator+(const Int &a, const Int &b)
	{ Int c; IasIplI(&c.I, &a.I, &b.I); return c; }
Int operator-(const Int &a, const Int &b)
	{ Int c; IasImiI(&c.I, &a.I, &b.I); return c; }

Int operator*(const Int &a, const Int &b)
	{ Int c; IasImuI(&c.I, &a.I, &b.I); return c; }

Int operator>>(const Int &a, unsigned int u)
	{ Int c; IasIsrint(&c.I, &a.I, u); return c; }
Int operator<<(const Int &a, unsigned int u)
	{ Int c; IasIslint(&c.I, &a.I, u); return c; }

Int operator/(const Int &a, const Int &b)
	{ Int c; IasIdiI(&c.I, &a.I, &b.I); return c; }
Int operator%(const Int &a, const Int &b)
	{ Int c; IasIreI(&c.I, &a.I, &b.I); return c; }

int fscanI(FILE * f, Int &a)
	{ return fscanI(f, &a.I); }
int fprintI(FILE * f, const Int &a)
	{ return fprintI(f, &a.I); }

int Itoa(const Int &a, char s[])
	{ return Itoa(&a.I, s); }
int atoI(char s[], Int &a)
	{ return atoI(s, &a.I); }

Int gcd(const Int &a, const Int &b)
	{ Int d; Igcd(&d.I, &a.I, &b.I); return d; }
Int bgcd(const Int &a, const Int &b)
	{ Int d; Ibgcd(&d.I, &a.I, &b.I); return d; }
Int dgcd(const Int &a, const Int &b)
	{ Int d; Idgcd(&d.I, &a.I, &b.I); return d; }
Int xgcd(Int &u, Int &v, const Int &a, const Int &b)
	{ Int d; Ixgcd(&d.I, &u.I, &v.I, &a.I, &b.I); return d; }
Int bxgcd(Int &u, Int &v, const Int &a, const Int &b)
	{ Int d; Ibxgcd(&d.I, &u.I, &v.I, &a.I, &b.I); return d; }

Int random(const Int &b)
	{ Int a; IasrandomI(&a.I, &b.I); return a; }
        /* Zufallsgenerator:
           waehle a zufaellig mit 0<=|a|<|b|, a->sign=b->sign.
 	*/

ostream& operator<<(ostream &out, const Int &a)
	{ 	int l=Ilog(a)+1;
		char *s=new char[l/3+2];
		Itoa(a, s);
		out<<s;
		delete s;
		return out;
	}

istream& operator>>(istream &in, Int &a)
	{	char s[IN_INT_BUF_LENGTH];
		in>>s;
		atoI(s, a);
		return in;
	}

