/* Integer Version 2.0, RD, 4.2.93	Int.h	*/

#ifndef _INT_H
#define _INT_H
 
#include <iostream.h>
#include "iint.h"

class Int {
	Integer	I;
public:
	Int()			{ cI(&I); }
	Int(int i)		{ cIasint(&I, i); }
	Int(unsigned int i)	{ cIasuint(&I, i); }
	Int(long i)		{ cIaslong(&I, i); }
	Int(unsigned long i)	{ cIasulong(&I, i); }
	Int(const Int &a)	{ cIasI(&I, &a.I); }
	~Int()			{ dI(&I); }

	Int& operator=(const Int &a)
		{ IasI(&I, &a.I); return *this; }
	int operator=(int i)
		{ Iasint(&I, i); return i; }

	friend BOOLEAN Iisint(const Integer *a)		{ return Iisint(a); }
	friend BOOLEAN Iisuint(const Integer *a)	{ return Iisuint(a); }
	friend BOOLEAN Iislong(const Integer *a)	{ return Iislong(a); }
	friend BOOLEAN Iisulong(const Integer *a)	{ return Iisulong(a); }
	friend int intasI(const Integer *a)		{ return intasI(a); }
	friend unsigned int uintasI(const Integer *a)	{ return uintasI(a); }
	friend long longasI(const Integer *a)		{ return longasI(a); }
	friend unsigned long ulongasI(const Integer *a)	{ return ulongasI(a); }

	friend int Ilog(const Int &a);
	friend Int operator+(const Int &a, const Int &b);
	friend Int operator-(const Int &a, const Int &b);
	Int& operator+=(const Int &a)
		{ IplasI(&I, &a.I); return *this; }
	Int& operator-=(const Int &a)
		{ ImiasI(&I, &a.I); return *this; }
	Int& operator++()
		{ Iinc(&I); return *this; }
	Int& operator--()
		{ Idec(&I); return *this; }

	BOOLEAN operator!()	{ return Ieq0(&I); }
	inline friend BOOLEAN operator==(const Int &a, const Int &b) 
		{ return IeqI(&a.I, &b.I); }
	inline friend BOOLEAN operator>(const Int &a, const Int &b) 
		{ return IgtI(&a.I, &b.I); }
	inline friend BOOLEAN operator!=(const Int &a, const Int &b) 
		{ return IneI(&a.I, &b.I); }
	inline friend BOOLEAN operator>=(const Int &a, const Int &b) 
		{ return IgeI(&a.I, &b.I); }
	inline friend BOOLEAN operator<(const Int &a, const Int &b) 
		{ return IltI(&a.I, &b.I); }
	inline friend BOOLEAN operator<=(const Int &a, const Int &b) 
		{ return IleI(&a.I, &b.I); }
	friend Int operator*(const Int &a, const Int &b);
	Int& operator*=(const Int &a)
		{ ImuasI(&I, &a.I); return *this; }
	friend Int operator>>(const Int &a, unsigned int u);
	friend Int operator<<(const Int &a, unsigned int u);
	Int& operator>>=(unsigned int u)
		{ Israsint(&I, u); return *this; }
	Int& operator<<=(unsigned int u)
		{ Islasint(&I, u); return *this; }
	inline friend BOOLEAN Isr1(Int &a) { return Isr1(&a.I); }
	inline friend BOOLEAN Ieven(const Int &a) { return Ieven(&a.I); }

	inline friend void Idiv(Int &q, Int &r, const Int &a, const Int &b)
		{ Idiv(&q.I, &r.I, &a.I, &b.I); }
	inline friend void uIdiv(Int &q, Int &r, const Int &a, const Int &b)
		{ uIdiv(&q.I, &r.I, &a.I, &b.I); }
	friend Int operator/(const Int &a, const Int &b);
	Int& operator/=(const Int &a)
		{ IdiasI(&I, &a.I); return *this; }
	friend Int operator%(const Int &a, const Int &b);
	Int& operator%=(const Int &a)
		{ IreasI(&I, &a.I); return *this; }

	friend int fscanI(FILE * f, Int &a);
	friend int fprintI(FILE * f, const Int &a);

	friend int Itoa(const Int &a, char s[]);
	friend int atoI(char s[], Int &a);

	friend Int gcd(const Int &a, const Int &b);	// "bester gcd" 
	friend Int bgcd(const Int &a, const Int &b);	// binaerer gcd
	friend Int dgcd(const Int &a, const Int &b);	// naiver gcd
	friend Int xgcd(Int &u, Int &v, const Int &a, const Int &b);
	friend Int bxgcd(Int &u, Int &v, const Int &a, const Int &b);

	friend Int random(const Int &b);
        /* Zufallsgenerator:
           waehle a zufaellig mit 0<=|a|<|b|, a->sign=b->sign.
 	*/
};

ostream& operator<<(ostream &out, const Int &a);
const IN_INT_BUF_LENGTH=10000;
istream& operator>>(istream &in, Int &a);

#endif
